
UPDATE pos_payments
SET sales_voucher_id = (
		SELECT sv.CANCEL_FOR_SALES_VOUCHER_ID
		FROM sales_vouchers sv
		WHERE sv.CANCEL_FOR_SALES_VOUCHER_ID IS NOT NULL
			AND sv.tenant_no = pos_payments.tenant_no
			AND sv.pos_cd = pos_payments.SALES_VOUCHER_POS_CD
			AND sv.sales_voucher_id = pos_payments.SALES_VOUCHER_ID
);





Delete from sales_vouchers  where CANCEL_FOR_SALES_VOUCHER_ID is not null;

--Geht nur so hässlich auf der Derby. Kein Umsetzen mehrerer Werte mit einem Select möglich
UPDATE pos_payments
SET SALES_VOUCHER_ID = (Select distinct sv.SALES_VOUCHER_ID from sales_vouchers sv   
			where pos_payments.PAYMENT_REF is not null and 
			sv.tenant_no = pos_payments.tenant_no
			AND sv.pos_cd = pos_payments.POS_CD
			AND lower(pos_payments.PAYMENT_REF) = lower(sv.SALES_VOUCHER_CD)),
SALES_VOUCHER_POS_CD= (Select distinct sv.POS_CD from sales_vouchers sv   
			where pos_payments.PAYMENT_REF is not null and 
			sv.tenant_no = pos_payments.tenant_no
			AND sv.pos_cd = pos_payments.POS_CD
			AND lower(pos_payments.PAYMENT_REF) = lower(sv.SALES_VOUCHER_CD))
		;
			

--Kontroll SQL: Sollte vor der Ausführung des Updates größere Lücken aufweisen. Nachher sollte für eine Payment_ref alles einheitlich gefüllt sein. Fehler in der Zuordnung durch Groß-/Kleinschreibung müssen behoben sein	
Select sv.SALES_VOUCHER_ID, pp.sales_voucher_id, pp.SALES_VOUCHER_POS_CD, pp.PAYMENT_REF, sv.SALES_VOUCHER_CD from pos_payments pp join sales_vouchers sv on  sv.tenant_no = pp.tenant_no
			AND sv.pos_cd = pp.POS_CD
			AND lower(pp.PAYMENT_REF) = lower(sv.SALES_VOUCHER_CD)
			where pp.PAYMENT_REF is not null;
			
	


Select * from sales_voucher_uses;

CREATE SEQUENCE sales_voucher_use_id
AS INTEGER
START WITH 1;

INSERT INTO sales_voucher_uses(TENANT_NO,POS_CD,SALES_VOUCHER_ID,SALES_VOUCHER_USE_ID,SALES_VOUCHER_USE_TS,CANCEL_REASON,USED_POS_CD,USED_DRAWER_NO,USED_POS_SESSION_ID,USED_POS_PAYMENT_ID,USED_SALES_INV_ID,USED_SALES_INV_CD,CUSTOMER_NO,CUSTOMER_SALUTATION,CUSTOMER_TITLE,CUSTOMER_FIRST_NM,CUSTOMER_CONTACT_NM,CUSTOMER_STREET,CUSTOMER_COUNTRY_CD,CUSTOMER_POSTAL_CD,CUSTOMER_CITY,CUSTOMER_CONTRACT_NO,CUSTOMER_CONTRACT_NM,EMPLOYEE_NO,EMPLOYEE_NM,VOUCHER_STATE,IS_LATEST 
 )
SELECT pp.TENANT_NO
	,pp.pos_cd
	,pp.sales_voucher_id
	,next value for sales_voucher_use_id
	,pp.PAYMENT_TS
	,pp.CANCEL_REASON
	,pp.SALES_VOUCHER_POS_CD
	,pp.DRAWER_NO
	,pp.POS_SESSION_ID
	,pp.POS_PAYMENT_ID
	,pp.SALES_INV_ID
	,si.SALES_INV_CD AS USED_SALES_INV_CD
	,si.CUSTOMER_NO
	,si.CUSTOMER_SALUTATION
	,si.CUSTOMER_TITLE
	,si.CUSTOMER_FIRST_NM
	,si.CUSTOMER_CONTACT_NM
	,si.CUSTOMER_STREET
	,si.CUSTOMER_COUNTRY_CD
	,si.CUSTOMER_POSTAL_CD
	,si.CUSTOMER_CITY
	,si.CUSTOMER_CONTRACT_NO
	,si.CUSTOMER_CONTRACT_NM
	,si.EMPLOYEE_NO
	,si.EMPLOYEE_NM
	,case pp.PAYMENT_DIRECTION  when  1 then (case  when pp.CANCEL_FOR_POS_SESSION_ID is not null then 2 else 3 end) 
		when  2 then(case when  pp.CANCEL_FOR_POS_SESSION_ID is not null then 5 else 1 end) end   as VOUCHER_STATE 
	, 0  as IS_LATEST
FROM POS_PAYMENTS pp
join SALES_INVS si on pp.tenant_no = si.tenant_no and pp.pos_cd = si.pos_cd and pp.SALES_INV_ID = si.SALES_INV_ID
where pp.sales_voucher_id > 0;
-- das gab Performance Probleme
--where pp.sales_voucher_id is not null;

DROP SEQUENCE sales_voucher_use_id RESTRICT;

UPDATE SALES_VOUCHER_USES 
SET IS_LATEST = 
(
Select case when SALES_VOUCHER_USES.sales_voucher_use_ts = MaxTS then 1 else 0 end as isLatest FROM
(Select tenant_no, pos_cd,  sales_voucher_id, max(sales_voucher_use_ts) as MaxTS from sales_voucher_uses svu2 group by tenant_no, pos_cd,  sales_voucher_id ) t
where  t.tenant_no = SALES_VOUCHER_USES.tenant_no and t.pos_cd = SALES_VOUCHER_USES.pos_cd and SALES_VOUCHER_USES.sales_voucher_id = t.sales_voucher_id 
);


UPDATE pos_payments set payment_booking_ts = payment_ts ;

UPDATE d_sales_dln_pos_work_records set operating_employee_factor = 1;

UPDATE sales_dln_pos_work_records set operating_employee_factor = 1;


INSERT INTO pos_day_closures (TENANT_NO, POS_CD, CLOSURE_DAY, CLOSURE_CHANGE_TS, EMPLOYEE_NM, STATUS, UPDATE_CNT)
Select distinct tenant_no, pos_cd, cast(cast(payment_ts as DATE)as timestamp), current_timestamp, 'Automated entry', 3, 1 FROM pos_payments;

INSERT INTO DRAWER_DAY_CLOSURES
Select distinct pd.tenant_no, pd.pos_cd, pd.DRAWER_NO , cast(cast(payment_ts as DATE)as timestamp),2, 'auto closed', 1 FROM pos_payments pp join pos_drawers pd on 1=1;


INSERT INTO EMPLOYEE_GROUPS Select tenant_no, company_no, 'Abschluss öffnen', 'Kassenabschluss öffnen' FROM COMPANIES where not exists(SELECT 1 from employee_groups eg where eg.employee_group_cd = 'Abschluss öffnen');
INSERT INTO EMPLOYEE_GROUPS Select tenant_no, company_no, 'Fillialbericht', 'Fillialbericht' FROM COMPANIES  where not exists(SELECT 1 from employee_groups eg where eg.employee_group_cd = 'Fillialbericht');
INSERT INTO EMPLOYEE_GROUPS Select tenant_no, company_no, 'Kassenabschluss', 'Kassenabschluss' FROM COMPANIES  where not exists(SELECT 1 from employee_groups eg where eg.employee_group_cd = 'Kassenabschluss');

insert into EMPLOYEE_GROUP_PERMISSIONS  Select tenant_no, company_no, 'Abschluss öffnen', 'P_OPEN_DAY_CLOSURE', 'Kassenabschluss öffnen' FROM COMPANIES where not exists(
SELECT 1 from EMPLOYEE_GROUP_PERMISSIONS egp where egp.EMPLOYEE_GROUP_CD = 'Abschluss öffnen' and egp.PERMISSION_CD = 'P_OPEN_DAY_CLOSURE');
insert into EMPLOYEE_GROUP_PERMISSIONS  Select tenant_no, company_no, 'Fillialbericht', 'P_POS_REPORT', 'Fillialbericht' FROM COMPANIES where not exists(
SELECT 1 from EMPLOYEE_GROUP_PERMISSIONS egp where egp.EMPLOYEE_GROUP_CD = 'Fillialbericht' and egp.PERMISSION_CD = 'P_POS_REPORT');
insert into EMPLOYEE_GROUP_PERMISSIONS  Select tenant_no, company_no, 'Kassenabschluss', 'P_DO_DAY_CLOSURE', 'Kassenabschluss' FROM COMPANIES where not exists(
SELECT 1 from EMPLOYEE_GROUP_PERMISSIONS egp where egp.EMPLOYEE_GROUP_CD = 'Kassenabschluss' and egp.PERMISSION_CD = 'P_DO_DAY_CLOSURE');
